## API Report File for "@microsoft/fast-foundation"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { Behavior } from '@microsoft/fast-element';
import { Constructable } from '@microsoft/fast-element';
import { DecoratorAttributeConfiguration } from '@microsoft/fast-element';
import { Direction } from '@microsoft/fast-web-utilities';
import { ElementStyles } from '@microsoft/fast-element';
import { FASTElement } from '@microsoft/fast-element';
import { Orientation } from '@microsoft/fast-web-utilities';
import { PartialFASTElementDefinition } from '@microsoft/fast-element';
import { ViewTemplate } from '@microsoft/fast-element';

// @public
export class Accordion extends FASTElement {
    // @internal (undocumented)
    accordionItems: HTMLElement[];
    // @internal (undocumented)
    accordionItemsChanged(oldValue: any, newValue: any): void;
    expandmode: AccordionExpandMode;
    }

// @public
export enum AccordionExpandMode {
    multi = "multi",
    single = "single"
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "AccordionItem" because one of its declarations is marked as @internal
//
// @public
export class AccordionItem extends FASTElement {
    // @internal (undocumented)
    clickHandler: (e: MouseEvent) => void;
    // @internal (undocumented)
    expandbutton: HTMLElement;
    expanded: boolean;
    headinglevel: 1 | 2 | 3 | 4 | 5 | 6;
    id: string;
}

// @internal
export interface AccordionItem extends StartEnd {
}

// @public
export const AccordionItemTemplate: import("@microsoft/fast-element").ViewTemplate<AccordionItem, any>;

// @public
export const AccordionTemplate: import("@microsoft/fast-element").ViewTemplate<Accordion, any>;

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "Anchor" because one of its declarations is marked as @internal
//
// @public
export class Anchor extends FASTElement {
    control: HTMLAnchorElement;
    // @internal
    defaultSlottedContent: HTMLElement[];
    download: string;
    href: string;
    hreflang: string;
    ping: string;
    referrerpolicy: string;
    rel: string;
    target: "_self" | "_blank" | "_parent" | "_top";
    type: string;
}

// @internal
export interface Anchor extends StartEnd, DelegatesARIALink {
}

// @beta
export class AnchoredRegion extends FASTElement {
    // @internal (undocumented)
    adoptedCallback(): void;
    anchor: string;
    anchorElement: HTMLElement | null;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal (undocumented)
    disconnectedCallback(): void;
    fixedPlacement: boolean;
    horizontalDefaultPosition: HorizontalPosition;
    horizontalInset: boolean;
    // Warning: (ae-forgotten-export) The symbol "AnchoredRegionHorizontalPositionLabel" needs to be exported by the entry point index.d.ts
    horizontalPosition: AnchoredRegionHorizontalPositionLabel;
    horizontalPositioningMode: AxisPositioningMode;
    horizontalScaling: AxisScalingMode;
    horizontalThreshold: number;
    // @internal
    initialLayoutComplete: boolean;
    update: () => void;
    updateAnchorOffset: (horizontalOffsetDelta: number, verticalOffsetDelta: number) => void;
    verticalDefaultPosition: VerticalPosition;
    verticalInset: boolean;
    // Warning: (ae-forgotten-export) The symbol "AnchoredRegionVerticalPositionLabel" needs to be exported by the entry point index.d.ts
    verticalPosition: AnchoredRegionVerticalPositionLabel;
    verticalPositioningMode: AxisPositioningMode;
    verticalScaling: AxisScalingMode;
    verticalThreshold: number;
    viewport: string;
    viewportElement: HTMLElement | null;
    }

// @beta
export const AnchoredRegionTemplate: import("@microsoft/fast-element").ViewTemplate<AnchoredRegion, any>;

// @public
export const AnchorTemplate: import("@microsoft/fast-element").ViewTemplate<Anchor, any>;

// @public
export function applyMixins(derivedCtor: any, ...baseCtors: any[]): void;

// @public
export class ARIAGlobalStatesAndProperties {
    ariaAtomic: "true" | "false";
    ariaBusy: "true" | "false";
    ariaControls: string;
    ariaCurrent: "page" | "step" | "location" | "date" | "time" | "true" | "false" | string;
    ariaDescribedby: string;
    ariaDetails: string;
    ariaDisabled: "true" | "false";
    ariaErrormessage: string;
    ariaFlowto: string;
    ariaHaspopup: "false" | "true" | "menu" | "listbox" | "tree" | "grid" | "dialog";
    ariaHidden: "false" | "true" | undefined;
    ariaInvalid: "false" | "true" | "grammar" | "spelling";
    ariaKeyshortcuts: string;
    ariaLabel: string;
    ariaLabelledby: string;
    ariaLive: "assertive" | "off" | "polite";
    ariaOwns: string;
    ariaRelevant: "additions" | "additions text" | "all" | "removals" | "text";
    ariaRoledescription: string;
}

// @beta
export type AxisPositioningMode = "uncontrolled" | "locktodefault" | "dynamic";

// @beta
export type AxisScalingMode = "anchor" | "fill" | "content";

// @public
export class Badge extends FASTElement {
    circular: boolean;
    color: string;
    fill: string;
    // (undocumented)
    generateBadgeStyle: () => string | undefined;
}

// @public
export const BadgeTemplate: import("@microsoft/fast-element").ViewTemplate<Badge, any>;

// @public
export class BaseProgress extends FASTElement {
    max: number;
    min: number;
    paused: any;
    value: number;
}

// @public
export class Breadcrumb extends FASTElement {
    // @internal (undocumented)
    slottedBreadcrumbItems: HTMLElement[];
    // (undocumented)
    slottedBreadcrumbItemsChanged(): void;
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "BreadcrumbItem" because one of its declarations is marked as @internal
//
// @public
export class BreadcrumbItem extends Anchor {
    // @internal (undocumented)
    separator: boolean;
}

// @internal
export interface BreadcrumbItem extends StartEnd, DelegatesARIALink {
}

// @public
export const BreadcrumbItemTemplate: import("@microsoft/fast-element").ViewTemplate<BreadcrumbItem, any>;

// @public
export const BreadcrumbTemplate: import("@microsoft/fast-element").ViewTemplate<Breadcrumb, any>;

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-forgotten-export) The symbol "FormAssociatedButton" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "Button" because one of its declarations is marked as @internal
//
// @public
export class Button extends FormAssociatedButton {
    autofocus: boolean;
    // @internal (undocumented)
    connectedCallback(): void;
    // (undocumented)
    control: HTMLButtonElement;
    defaultSlottedContent: HTMLElement[];
    formaction: string;
    formenctype: string;
    formId: string;
    formmethod: string;
    formnovalidate: boolean;
    formtarget: "_self" | "_blank" | "_parent" | "_top";
    // @deprecated (undocumented)
    get root(): HTMLButtonElement;
    type: "submit" | "reset" | "button";
    }

// @internal
export interface Button extends StartEnd, DelegatesARIAButton {
}

// @public
export const ButtonTemplate: import("@microsoft/fast-element").ViewTemplate<Button, any>;

// @public
export class Card extends FASTElement {
}

// @public
export const CardTemplate: import("@microsoft/fast-element").ViewTemplate<Card, any>;

// Warning: (ae-forgotten-export) The symbol "FormAssociatedCheckbox" needs to be exported by the entry point index.d.ts
//
// @public
export class Checkbox extends FormAssociatedCheckbox {
    constructor();
    checked: boolean;
    checkedAttribute: boolean;
    // @internal (undocumented)
    clickHandler: (e: MouseEvent) => void;
    // @internal (undocumented)
    connectedCallback(): void;
    defaultChecked: boolean;
    // @internal (undocumented)
    defaultSlottedNodes: Node[];
    // @internal (undocumented)
    formResetCallback: () => void;
    indeterminate: boolean;
    // @internal
    initialValue: string;
    // @internal (undocumented)
    keypressHandler: (e: KeyboardEvent) => void;
    readOnly: boolean;
    }

// @public
export const CheckboxTemplate: import("@microsoft/fast-element").ViewTemplate<Checkbox, any>;

// @public
export interface ColumnDefinition {
    cellFocusTargetCallback?: (cell: DataGridCell) => HTMLElement;
    cellInternalFocusQueue?: boolean;
    cellTemplate?: ViewTemplate;
    columnDataKey: string;
    gridColumn?: string;
    headerCellFocusTargetCallback?: (cell: DataGridCell) => HTMLElement;
    headerCellInternalFocusQueue?: boolean;
    headerCellTemplate?: ViewTemplate;
    title?: string;
}

// @public
export function composedParent<T extends HTMLElement>(element: T): HTMLElement | null;

// @alpha
export type ConstructableFormAssociated = Constructable<FASTElement & HTMLElement & FormAssociatedProxy>;

// Warning: (ae-forgotten-export) The symbol "CustomPropertyManagerBase" needs to be exported by the entry point index.d.ts
//
// @public
export class ConstructableStylesCustomPropertyManager extends CustomPropertyManagerBase {
    constructor(sheet: CSSStyleSheet);
    // (undocumented)
    protected customPropertyTarget: CSSStyleDeclaration;
    isSubscribed(client: CustomPropertyManagerClient): boolean;
    // (undocumented)
    protected readonly sheet: CSSStyleSheet;
    // (undocumented)
    protected styles: ElementStyles;
    subscribe(client: CustomPropertyManagerClient): void;
    unsubscribe(client: CustomPropertyManagerClient): void;
}

// @public
export function createDataGridCellTemplate(prefix: string): ViewTemplate;

// @public
export function createDataGridRowTemplate(prefix: string): ViewTemplate;

// @public
export function createDataGridTemplate(prefix: string): ViewTemplate;

// @public
export function createTooltipTemplate(prefix: string): ViewTemplate;

// @public
export class CSSCustomPropertyBehavior implements Behavior, CSSCustomPropertyDefinition {
    constructor(name: string, value: CSSCustomPropertyDefinition["value"], host: (source: HTMLElement) => Partial<CSSCustomPropertyTarget> | null);
    // @internal
    bind(source: HTMLElement): void;
    readonly name: CSSCustomPropertyDefinition["name"];
    readonly propertyName: string;
    // @internal
    unbind(source: HTMLElement): void;
    readonly value: CSSCustomPropertyDefinition["value"];
    readonly var: string;
}

// @public
export function cssCustomPropertyBehaviorFactory(name: string, value: string | ((...arg: any[]) => string), host: (source: typeof FASTElement & HTMLElement) => Partial<CSSCustomPropertyTarget> | null): CSSCustomPropertyBehavior;

// @public
export interface CSSCustomPropertyDefinition {
    name: string;
    value: string | ((...args: any[]) => string);
}

// @public
export interface CSSCustomPropertyTarget {
    // (undocumented)
    disconnectedCSSCustomPropertyRegistry: CSSCustomPropertyDefinition[] | void;
    // (undocumented)
    registerCSSCustomProperty(behavior: CSSCustomPropertyDefinition): void;
    // (undocumented)
    unregisterCSSCustomProperty(behavior: CSSCustomPropertyDefinition): void;
}

// @public
export type CSSDisplayPropertyValue = "block" | "contents" | "flex" | "grid" | "inherit" | "initial" | "inline" | "inline-block" | "inline-flex" | "inline-grid" | "inline-table" | "list-item" | "none" | "run-in" | "table" | "table-caption" | "table-cell" | "table-column" | "table-column-group" | "table-footer-group" | "table-header-group" | "table-row" | "table-row-group";

// @public
export interface CustomPropertyManager {
    isSubscribed?(provider: CustomPropertyManagerClient): boolean;
    readonly owner: CustomPropertyManagerClient | null;
    register(definition: CSSCustomPropertyDefinition): void;
    remove(name: string): void;
    set(definition: CSSCustomPropertyDefinition): void;
    setAll(): void;
    subscribe?(provider: CustomPropertyManagerClient): void;
    unregister(name: string): void;
    unsubscribe?(provider: CustomPropertyManagerClient): void;
}

// @public
export interface CustomPropertyManagerClient extends FASTElement, HTMLElement {
    cssCustomPropertyDefinitions: Map<string, CSSCustomPropertyDefinition>;
    evaluate(definition: CSSCustomPropertyDefinition): string;
}

// @public
export class DataGrid extends FASTElement {
    constructor();
    cellItemTemplate?: ViewTemplate;
    columnDefinitions: ColumnDefinition[] | null;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal
    defaultRowItemTemplate: ViewTemplate;
    // @internal (undocumented)
    disconnectedCallback(): void;
    focusColumnIndex: number;
    focusRowIndex: number;
    static generateColumns: (row: object) => ColumnDefinition[];
    generateHeader: GenerateHeaderOptions;
    gridTemplateColumns: string;
    // @internal (undocumented)
    handleFocus(e: FocusEvent): void;
    // @internal (undocumented)
    handleKeydown(e: KeyboardEvent): void;
    // @internal (undocumented)
    handleRowFocus(e: Event): void;
    headerCellItemTemplate?: ViewTemplate;
    // @internal
    rowElements: HTMLElement[];
    rowItemTemplate: ViewTemplate;
    rowsData: object[];
    }

// @public
export class DataGridCell extends FASTElement {
    cellType: DataGridCellTypes;
    columnDefinition: ColumnDefinition | null;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal (undocumented)
    disconnectedCallback(): void;
    gridColumn: string;
    // (undocumented)
    handleFocusin(e: FocusEvent): void;
    // (undocumented)
    handleFocusout(e: FocusEvent): void;
    // (undocumented)
    handleKeydown(e: KeyboardEvent): void;
    rowData: object | null;
    }

// @public
export enum DataGridCellTypes {
    // (undocumented)
    columnHeader = "columnheader",
    // (undocumented)
    default = "default"
}

// @public
export class DataGridRow extends FASTElement {
    // @internal
    activeCellItemTemplate?: ViewTemplate;
    // @internal
    cellElements: HTMLElement[];
    cellItemTemplate?: ViewTemplate;
    columnDefinitions: ColumnDefinition[] | null;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal
    defaultCellItemTemplate?: ViewTemplate;
    // @internal
    defaultHeaderCellItemTemplate?: ViewTemplate;
    // @internal (undocumented)
    disconnectedCallback(): void;
    // @internal (undocumented)
    focusColumnIndex: number;
    gridTemplateColumns: string;
    // (undocumented)
    handleCellFocus(e: Event): void;
    // (undocumented)
    handleFocusout(e: FocusEvent): void;
    // (undocumented)
    handleKeydown(e: KeyboardEvent): void;
    headerCellItemTemplate?: ViewTemplate;
    // @internal
    isActiveRow: boolean;
    rowData: object | null;
    rowIndex: number;
    rowType: DataGridRowTypes;
    // @internal (undocumented)
    slottedCellElements: HTMLElement[];
    }

// @public
export enum DataGridRowTypes {
    // (undocumented)
    default = "default",
    // (undocumented)
    header = "header",
    // (undocumented)
    stickyHeader = "sticky-header"
}

// @public
export interface DecoratorDesignSystemPropertyConfiguration extends Omit<DecoratorAttributeConfiguration, "attribute"> {
    attribute?: string | false;
    cssCustomProperty?: string | false;
    default: any;
}

// @public
export function defineDesignSystemProvider(nameOrDef: string | PartialFASTElementDefinition): <T extends typeof DesignSystemProvider>(providerCtor: T) => void;

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "DelegatesARIAButton" because one of its declarations is marked as @internal
//
// @public
export class DelegatesARIAButton {
    ariaExpanded: "true" | "false" | undefined;
    ariaPressed: "true" | "false" | "mixed" | undefined;
}

// @internal
export interface DelegatesARIAButton extends ARIAGlobalStatesAndProperties {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "DelegatesARIALink" because one of its declarations is marked as @internal
//
// @public
export class DelegatesARIALink {
    ariaExpanded: "true" | "false" | undefined;
}

// @internal
export interface DelegatesARIALink extends ARIAGlobalStatesAndProperties {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "DelegatesARIAListbox" because one of its declarations is marked as @internal
//
// @public
export class DelegatesARIAListbox {
    ariaActiveDescendant: string;
    ariaDisabled: "true" | "false";
    ariaExpanded: "true" | "false" | undefined;
}

// @internal
export interface DelegatesARIAListbox extends ARIAGlobalStatesAndProperties {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "DelegatesARIASelect" because one of its declarations is marked as @internal
//
// @public
export class DelegatesARIASelect {
    ariaExpanded: "true" | "false" | undefined;
    ariaPressed: "true" | "false" | "mixed" | undefined;
}

// @internal
export interface DelegatesARIASelect extends ARIAGlobalStatesAndProperties {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "DelegatesARIATextbox" because one of its declarations is marked as @internal
//
// @public
export class DelegatesARIATextbox {
}

// @internal
export interface DelegatesARIATextbox extends ARIAGlobalStatesAndProperties {
}

// @public
export interface DesignSystemConsumer {
    // (undocumented)
    provider: DesignSystemProvider | null;
}

// @public
export const designSystemConsumerBehavior: Behavior;

// @public
export function designSystemProperty<T extends DesignSystemProvider>(config: DecoratorDesignSystemPropertyConfiguration): (source: T, property: string) => void;

// @public
export class DesignSystemProvider extends FASTElement implements CSSCustomPropertyTarget, DesignSystemConsumer, CustomPropertyManagerClient {
    constructor();
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal
    cssCustomPropertyDefinitions: Map<string, CSSCustomPropertyDefinition>;
    customPropertyManager: CustomPropertyManager;
    designSystem: {};
    // @internal
    designSystemProperties: {
        [propertyName: string]: Required<Pick<DecoratorDesignSystemPropertyConfiguration, "cssCustomProperty" | "default">>;
    };
    // (undocumented)
    disconnectedCallback(): void;
    // @deprecated
    disconnectedCSSCustomPropertyRegistry: CSSCustomPropertyDefinition[];
    disconnectedRegistry: Array<(provider: DesignSystemProvider) => void> | void;
    evaluate(definition: CSSCustomPropertyDefinition): string;
    static findProvider(el: HTMLElement & Partial<DesignSystemConsumer>): DesignSystemProvider | null;
    static isDesignSystemProvider(el: HTMLElement | DesignSystemProvider): el is DesignSystemProvider;
    readonly isDesignSystemProvider = true;
    provider: DesignSystemProvider | null;
    registerCSSCustomProperty(def: CSSCustomPropertyDefinition): void;
    static registerTagName(tagName: string): void;
    static get tagNames(): string[];
    unregisterCSSCustomProperty(def: CSSCustomPropertyDefinition): void;
    useDefaults: boolean;
    }

// Warning: (ae-internal-missing-underscore) The name "designSystemProvider" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal @deprecated (undocumented)
export const designSystemProvider: typeof defineDesignSystemProvider;

// @public
export const DesignSystemProviderTemplate: import("@microsoft/fast-element").ViewTemplate<DesignSystemProvider, any>;

// @public
export class Dialog extends FASTElement {
    ariaDescribedby: string;
    ariaLabel: string;
    ariaLabelledby: string;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal (undocumented)
    dialog: HTMLDivElement;
    // @internal (undocumented)
    disconnectedCallback(): void;
    // @internal (undocumented)
    dismiss(): void;
    hidden: boolean;
    hide(): void;
    modal: boolean;
    show(): void;
    trapFocus: boolean;
    }

// @public
export const DialogTemplate: import("@microsoft/fast-element").ViewTemplate<Dialog, any>;

// @public
export class DirectionalStyleSheetBehavior implements Behavior {
    constructor(ltr: ElementStyles | null, rtl: ElementStyles | null);
    // @internal (undocumented)
    bind(source: FASTElement & HTMLElement): void;
    // @internal (undocumented)
    unbind(source: FASTElement & HTMLElement): void;
}

// @public
export const disabledCursor = "not-allowed";

// @public
export class Disclosure extends FASTElement {
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal (undocumented)
    details: HTMLDetailsElement;
    // @internal (undocumented)
    disconnectedCallback(): void;
    expanded: boolean;
    hide(): void;
    protected onToggle(): void;
    protected setup(): void;
    show(): void;
    title: string;
    toggle(): void;
}

// @public
export const DisclosureTemplate: import("@microsoft/fast-element").ViewTemplate<Disclosure, any>;

// @public
export function display(displayValue: CSSDisplayPropertyValue): string;

// @public
export class Divider extends FASTElement {
    role: DividerRole;
}

// @public
export enum DividerRole {
    presentation = "presentation",
    separator = "separator"
}

// @public
export const DividerTemplate: import("@microsoft/fast-element").ViewTemplate<Divider, any>;

// @public
export const endTemplate: import("@microsoft/fast-element").ViewTemplate<StartEnd, any>;

// @public
export class Flipper extends FASTElement {
    direction: FlipperDirection;
    disabled: boolean;
    hiddenFromAT: boolean;
}

// @public
export enum FlipperDirection {
    // (undocumented)
    next = "next",
    // (undocumented)
    previous = "previous"
}

// @public
export const FlipperTemplate: import("@microsoft/fast-element").ViewTemplate<Flipper, any>;

// @public
export const focusVisible: string;

// @public
export const forcedColorsStylesheetBehavior: (styles: ElementStyles) => MatchMediaStyleSheetBehavior;

// @alpha
export function FormAssociated<T extends ConstructableFormAssociated>(BaseCtor: T): T;

// Warning: (ae-forgotten-export) The symbol "ElementInternals" needs to be exported by the entry point index.d.ts
//
// @alpha
export interface FormAssociated extends Omit<ElementInternals, "labels"> {
    // (undocumented)
    attachProxy(): void;
    // (undocumented)
    detachProxy(): void;
    // (undocumented)
    dirtyValue: boolean;
    // (undocumented)
    disabled: boolean;
    // (undocumented)
    disabledChanged?(previous: boolean, next: boolean): void;
    // (undocumented)
    readonly elementInternals: ElementInternals | null;
    // (undocumented)
    readonly formAssociated: boolean;
    // (undocumented)
    formDisabledCallback?(disabled: boolean): void;
    // (undocumented)
    formResetCallback(): void;
    // (undocumented)
    initialValue: string;
    // (undocumented)
    initialValueChanged?(previous: any, next: any): void;
    // (undocumented)
    readonly labels: ReadonlyArray<Node[]>;
    // (undocumented)
    name: string;
    // (undocumented)
    nameChanged?(previous: any, next: any): void;
    // (undocumented)
    required: boolean;
    // (undocumented)
    requiredChanged(prev: boolean, next: boolean): void;
    // (undocumented)
    stopPropagation(e: Event): void;
    // (undocumented)
    validate(): void;
    // (undocumented)
    value: string;
    // (undocumented)
    valueChanged(previous: any, next: any): void;
}

// @alpha
export type FormAssociatedElement = FormAssociated & FASTElement & HTMLElement & FormAssociatedProxy;

// @alpha
export interface FormAssociatedProxy {
    // (undocumented)
    disabledChanged?(previous: boolean, next: boolean): void;
    // (undocumented)
    formDisabledCallback?(disabled: boolean): void;
    // (undocumented)
    formResetCallback?(): void;
    // (undocumented)
    initialValueChanged?(previous: any, next: any): void;
    // (undocumented)
    nameChanged?(previous: any, next: any): void;
    // (undocumented)
    proxy: HTMLSelectElement | HTMLTextAreaElement | HTMLInputElement;
    // (undocumented)
    valueChanged?(previous: any, next: any): void;
}

// @public
export enum GenerateHeaderOptions {
    // (undocumented)
    default = "default",
    // (undocumented)
    none = "none",
    // (undocumented)
    sticky = "sticky"
}

// @public
export const getDirection: (rootNode: HTMLElement) => Direction;

// @public
export const hidden = ":host([hidden]){display:none}";

// @beta
export type HorizontalPosition = "start" | "end" | "left" | "right" | "unset";

// @public
export function isDesignSystemConsumer(element: HTMLElement | DesignSystemConsumer): element is DesignSystemConsumer;

// @public
export function isListboxOption(el: Element): el is ListboxOption;

// @public
export function isTreeItemElement(el: Element): el is HTMLElement;

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "Listbox" because one of its declarations is marked as @internal
//
// @public
export class Listbox extends FASTElement {
    // @internal
    clickHandler(e: MouseEvent): boolean | void;
    disabled: boolean;
    // @internal (undocumented)
    get firstSelectedOption(): ListboxOption;
    // @internal (undocumented)
    protected focusAndScrollOptionIntoView(): void;
    // @internal (undocumented)
    focusinHandler(e: FocusEvent): void;
    handleTypeAhead(key: any): void;
    // @internal
    keydownHandler(e: KeyboardEvent): boolean | void;
    // (undocumented)
    get length(): number;
    options: ListboxOption[];
    role: string;
    selectedIndex: number;
    // (undocumented)
    selectedIndexChanged(prev: number, next: number): void;
    selectedOptions: ListboxOption[];
    // (undocumented)
    protected selectedOptionsChanged(prev: any, next: any): void;
    selectFirstOption(): void;
    // @internal
    selectLastOption(): void;
    // @internal
    selectNextOption(): void;
    // @internal
    selectPreviousOption(): void;
    // @internal (undocumented)
    protected setDefaultSelectedOption(): void;
    protected setSelectedOptions(): void;
    static slottedOptionFilter: (n: HTMLElement) => boolean;
    // @internal (undocumented)
    slottedOptions: HTMLElement[];
    // (undocumented)
    slottedOptionsChanged(prev: any, next: any): void;
    // @internal
    protected typeAheadExpired: boolean;
    }

// @internal (undocumented)
export interface Listbox extends DelegatesARIAListbox {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "ListboxOption" because one of its declarations is marked as @internal
//
// @public
export class ListboxOption extends FASTElement {
    constructor(text?: string, value?: string, defaultSelected?: boolean, selected?: boolean);
    defaultSelected: boolean;
    // (undocumented)
    protected defaultSelectedChanged(): void;
    dirtyValue: boolean;
    disabled: boolean;
    // (undocumented)
    protected disabledChanged(prev: any, next: any): void;
    // (undocumented)
    get form(): HTMLFormElement | null;
    protected initialValue: string;
    // (undocumented)
    initialValueChanged(previous: string, next: string): void;
    // (undocumented)
    get label(): string;
    // (undocumented)
    proxy: HTMLOptionElement;
    selected: boolean;
    selectedAttribute: boolean;
    // (undocumented)
    protected selectedAttributeChanged(): void;
    // (undocumented)
    protected selectedChanged(): void;
    // (undocumented)
    get text(): string;
    // (undocumented)
    value: string;
    // (undocumented)
    valueChanged(previous: string, next: string): void;
}

// @internal (undocumented)
export interface ListboxOption extends StartEnd {
}

// @public
export const ListboxOptionTemplate: import("@microsoft/fast-element").ViewTemplate<ListboxOption, any>;

// @public
export enum ListboxRole {
    // (undocumented)
    listbox = "listbox"
}

// @public
export const ListboxTemplate: import("@microsoft/fast-element").ViewTemplate<Listbox, any>;

// @public
export abstract class MatchMediaBehavior implements Behavior {
    constructor(query: MediaQueryList);
    bind(source: typeof FASTElement & HTMLElement): void;
    protected abstract constructListener(source: typeof FASTElement): MediaQueryListListener;
    readonly query: MediaQueryList;
    unbind(source: typeof FASTElement & HTMLElement): void;
}

// @public
export class MatchMediaStyleSheetBehavior extends MatchMediaBehavior {
    constructor(query: MediaQueryList, styles: ElementStyles);
    // @internal
    protected constructListener(source: typeof FASTElement): MediaQueryListListener;
    readonly query: MediaQueryList;
    readonly styles: ElementStyles;
    // @internal
    unbind(source: typeof FASTElement & HTMLElement): void;
    static with(query: MediaQueryList): (styles: ElementStyles) => MatchMediaStyleSheetBehavior;
}

// @public @deprecated
export function matchMediaStylesheetBehaviorFactory(query: MediaQueryList): (styles: ElementStyles) => MatchMediaStyleSheetBehavior;

// @public
export type MediaQueryListListener = (this: MediaQueryList, ev?: MediaQueryListEvent) => void;

// @public
export class Menu extends FASTElement {
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal (undocumented)
    disconnectedCallback(): void;
    focus(): void;
    // @internal
    handleFocusOut: (e: FocusEvent) => void;
    // @internal (undocumented)
    handleMenuKeyDown(e: KeyboardEvent): void | boolean;
    // @internal (undocumented)
    items: HTMLSlotElement;
    }

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "MenuItem" because one of its declarations is marked as @internal
//
// @public
export class MenuItem extends FASTElement {
    checked: boolean;
    disabled: boolean;
    expanded: boolean;
    // @internal (undocumented)
    handleMenuItemClick: (e: MouseEvent) => void;
    // @internal (undocumented)
    handleMenuItemKeyDown: (e: KeyboardEvent) => boolean;
    role: MenuItemRole;
}

// @internal
export interface MenuItem extends StartEnd {
}

// @public
export enum MenuItemRole {
    menuitem = "menuitem",
    menuitemcheckbox = "menuitemcheckbox",
    menuitemradio = "menuitemradio"
}

// @public
export const MenuItemTemplate: import("@microsoft/fast-element").ViewTemplate<MenuItem, any>;

// @public
export const MenuTemplate: import("@microsoft/fast-element").ViewTemplate<Menu, any>;

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-forgotten-export) The symbol "FormAssociatedNumberField" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "NumberField" because one of its declarations is marked as @internal
//
// @public
export class NumberField extends FormAssociatedNumberField {
    autofocus: boolean;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal
    control: HTMLInputElement;
    // @internal (undocumented)
    defaultSlottedNodes: Node[];
    // @internal
    handleChange(): void;
    // @internal
    handleTextInput(): void;
    list: string;
    max: number;
    // (undocumented)
    maxChanged(previousValue: any, nextValue: any): void;
    maxlength: number;
    min: number;
    // (undocumented)
    minChanged(previousValue: any, nextValue: any): void;
    minlength: number;
    placeholder: string;
    readOnly: boolean;
    size: number;
    step: number;
    stepDown(): void;
    stepUp(): void;
    // (undocumented)
    valueChanged(previousValue: any, nextValue: any): void;
}

// @internal
export interface NumberField extends StartEnd, DelegatesARIATextbox {
}

// @public
export const NumberFieldTemplate: import("@microsoft/fast-element").ViewTemplate<NumberField, any>;

// @public
export const ProgressRingTemplate: import("@microsoft/fast-element").ViewTemplate<BaseProgress, any>;

// @public
export const ProgressTemplate: import("@microsoft/fast-element").ViewTemplate<BaseProgress, any>;

// @public
export class PropertyStyleSheetBehavior implements Behavior {
    constructor(propertyName: string, value: any, styles: ElementStyles);
    bind(elementInstance: FASTElement): void;
    // @internal
    handleChange(source: FASTElement, key: any): void;
    // @internal
    unbind(source: typeof FASTElement & HTMLElement): void;
    }

// Warning: (ae-forgotten-export) The symbol "FormAssociatedRadio" needs to be exported by the entry point index.d.ts
//
// @public
export class Radio extends FormAssociatedRadio implements RadioControl {
    checked: boolean;
    checkedAttribute: boolean;
    // @internal (undocumented)
    clickHandler: (e: MouseEvent) => void;
    // @internal (undocumented)
    connectedCallback(): void;
    defaultChecked: boolean | undefined;
    // @internal (undocumented)
    defaultSlottedNodes: Node[];
    // @internal (undocumented)
    formResetCallback: () => void;
    // @internal
    initialValue: string;
    // @internal (undocumented)
    keypressHandler: (e: KeyboardEvent) => void;
    name: string;
    readOnly: boolean;
    }

// @public
export type RadioControl = Pick<HTMLInputElement, "checked" | "disabled" | "readOnly" | "focus" | "setAttribute" | "getAttribute">;

// @public
export class RadioGroup extends FASTElement {
    // (undocumented)
    childItems: HTMLElement[];
    // @internal (undocumented)
    clickHandler: (e: MouseEvent) => void;
    // @internal (undocumented)
    connectedCallback(): void;
    disabled: boolean;
    // (undocumented)
    disconnectedCallback(): void;
    // @internal (undocumented)
    focusOutHandler: (e: FocusEvent) => boolean | void;
    // @internal
    keydownHandler: (e: KeyboardEvent) => boolean | void;
    name: string;
    // (undocumented)
    protected nameChanged(): void;
    orientation: Orientation;
    readOnly: boolean;
    // @internal (undocumented)
    slottedRadioButtons: HTMLElement[];
    value: string;
    // (undocumented)
    protected valueChanged(): void;
}

// @public
export const RadioGroupTemplate: import("@microsoft/fast-element").ViewTemplate<RadioGroup, any>;

// @public
export const RadioTemplate: import("@microsoft/fast-element").ViewTemplate<Radio, any>;

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-forgotten-export) The symbol "FormAssociatedSelect" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "Select" because one of its declarations is marked as @internal
//
// @public
export class Select extends FormAssociatedSelect {
    // @internal
    clickHandler(e: MouseEvent): boolean | void;
    // (undocumented)
    connectedCallback(): void;
    // @internal
    disabledChanged(prev: boolean, next: boolean): void;
    displayValue: string;
    // @internal
    focusoutHandler(e: FocusEvent): boolean | void;
    // @internal
    formResetCallback: () => void;
    // @internal
    keydownHandler(e: KeyboardEvent): boolean | void;
    // @internal
    maxHeight: number;
    // @internal
    open: boolean;
    // (undocumented)
    protected openChanged(): void;
    position: SelectPosition;
    positionAttribute: SelectPosition;
    role: SelectRole;
    // @internal
    selectedIndexChanged(prev: any, next: any): void;
    setPositioning(): void;
    // @internal
    slottedOptionsChanged(prev: any, next: any): void;
    get value(): string;
    set value(next: string);
    }

// @internal (undocumented)
export interface Select extends StartEnd, DelegatesARIASelect {
}

// @public
export enum SelectPosition {
    // (undocumented)
    above = "above",
    // (undocumented)
    below = "below"
}

// @public
export enum SelectRole {
    // (undocumented)
    combobox = "combobox"
}

// @public
export const SelectTemplate: import("@microsoft/fast-element").ViewTemplate<Select, any>;

// @public
export class Skeleton extends FASTElement {
    fill: string;
    pattern: string;
    shape: SkeletonShape;
    shimmer: boolean;
}

// @public
export type SkeletonShape = "rect" | "circle";

// @public
export const SkeletonTemplate: import("@microsoft/fast-element").ViewTemplate<Skeleton, any>;

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-forgotten-export) The symbol "FormAssociatedSlider" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "Slider" because one of its declarations is marked as @internal
//
// @public
export class Slider extends FormAssociatedSlider implements SliderConfiguration {
    // @internal (undocumented)
    connectedCallback(): void;
    decrement(): void;
    // @internal (undocumented)
    direction: Direction;
    // @internal (undocumented)
    disconnectedCallback(): void;
    increment(): void;
    // @internal (undocumented)
    initialValue: string;
    // @internal (undocumented)
    isDragging: boolean;
    // (undocumented)
    protected keypressHandler: (e: KeyboardEvent) => void;
    max: number;
    min: number;
    mode: SliderMode;
    orientation: Orientation;
    // @internal (undocumented)
    position: string;
    readOnly: boolean;
    step: number;
    // @internal (undocumented)
    thumb: HTMLDivElement;
    // @internal (undocumented)
    track: HTMLDivElement;
    // @internal (undocumented)
    trackHeight: number;
    // @internal (undocumented)
    trackLeft: number;
    // @internal (undocumented)
    trackMinHeight: number;
    // @internal (undocumented)
    trackMinWidth: number;
    // @internal (undocumented)
    trackWidth: number;
    // @internal (undocumented)
    valueChanged(previous: any, next: any): void;
    valueTextFormatter: (value: string) => string | null;
}

// @internal (undocumented)
export interface Slider extends FormAssociatedSlider {
}

// @public
export interface SliderConfiguration {
    // (undocumented)
    direction?: Direction;
    // (undocumented)
    disabled?: boolean;
    // (undocumented)
    max: number;
    // (undocumented)
    min: number;
    // (undocumented)
    orientation?: Orientation;
}

// @public
export class SliderLabel extends FASTElement {
    // @internal (undocumented)
    connectedCallback(): void;
    disabled: boolean;
    // @internal (undocumented)
    disconnectedCallback(): void;
    // @internal (undocumented)
    handleChange(source: any, propertyName: string): void;
    hideMark: boolean;
    position: string;
    // @internal (undocumented)
    positionStyle: string;
    // @internal (undocumented)
    root: HTMLDivElement;
    // @internal (undocumented)
    sliderDirection: Direction;
    // @internal (undocumented)
    sliderMaxPosition: number;
    // @internal (undocumented)
    sliderMinPosition: number;
    // @internal (undocumented)
    sliderOrientation: Orientation;
    // @internal (undocumented)
    protected sliderOrientationChanged(): void;
}

// @public
export const SliderLabelTemplate: import("@microsoft/fast-element").ViewTemplate<SliderLabel, any>;

// @public
export enum SliderMode {
    // (undocumented)
    singleValue = "single-value"
}

// @public
export const SliderTemplate: import("@microsoft/fast-element").ViewTemplate<Slider, any>;

// @public
export class StartEnd {
    // (undocumented)
    end: HTMLSlotElement;
    // (undocumented)
    endContainer: HTMLSpanElement;
    // (undocumented)
    handleEndContentChange(): void;
    // (undocumented)
    handleStartContentChange(): void;
    // (undocumented)
    start: HTMLSlotElement;
    // (undocumented)
    startContainer: HTMLSpanElement;
}

// @public
export const startTemplate: import("@microsoft/fast-element").ViewTemplate<StartEnd, any>;

// @public
export class StyleElementCustomPropertyManager extends CustomPropertyManagerBase {
    constructor(style: HTMLStyleElement, client: CustomPropertyManagerClient);
    // (undocumented)
    protected customPropertyTarget: CSSStyleDeclaration;
    // (undocumented)
    get sheet(): CSSStyleSheet | null;
    // (undocumented)
    readonly styles: HTMLStyleElement;
}

// @alpha (undocumented)
export const supportsElementInternals: boolean;

// Warning: (ae-forgotten-export) The symbol "FormAssociatedSwitch" needs to be exported by the entry point index.d.ts
//
// @public
export class Switch extends FormAssociatedSwitch {
    checked: boolean;
    checkedAttribute: boolean;
    // @internal (undocumented)
    clickHandler: (e: MouseEvent) => void;
    // @internal (undocumented)
    connectedCallback(): void;
    defaultChecked: boolean;
    // @internal (undocumented)
    defaultSlottedNodes: Node[];
    // @internal (undocumented)
    formResetCallback: () => void;
    // @internal
    initialValue: string;
    // @internal (undocumented)
    keypressHandler: (e: KeyboardEvent) => void;
    readOnly: boolean;
    }

// @public
export const SwitchTemplate: import("@microsoft/fast-element").ViewTemplate<Switch, any>;

// @public
export class Tab extends FASTElement {
    disabled: boolean;
}

// @public
export class TabPanel extends FASTElement {
}

// @public
export const TabPanelTemplate: import("@microsoft/fast-element").ViewTemplate<TabPanel, any>;

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "Tabs" because one of its declarations is marked as @internal
//
// @public
export class Tabs extends FASTElement {
    activeid: string;
    // @internal (undocumented)
    activeidChanged(): void;
    activeindicator: boolean;
    // @internal (undocumented)
    activeIndicatorRef: HTMLElement;
    activetab: HTMLElement;
    adjust(adjustment: number): void;
    // @internal (undocumented)
    connectedCallback(): void;
    orientation: TabsOrientation;
    // @internal (undocumented)
    showActiveIndicator: boolean;
    // @internal (undocumented)
    tabpanels: HTMLElement[];
    // @internal (undocumented)
    tabpanelsChanged(): void;
    // @internal (undocumented)
    tabs: HTMLElement[];
    // @internal (undocumented)
    tabsChanged(): void;
    }

// @internal
export interface Tabs extends StartEnd {
}

// @public
export enum TabsOrientation {
    // (undocumented)
    horizontal = "horizontal",
    // (undocumented)
    vertical = "vertical"
}

// @public
export const TabsTemplate: import("@microsoft/fast-element").ViewTemplate<Tabs, any>;

// @public
export const TabTemplate: import("@microsoft/fast-element").ViewTemplate<Tab, any>;

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-forgotten-export) The symbol "FormAssociatedTextArea" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "TextArea" because one of its declarations is marked as @internal
//
// @public
export class TextArea extends FormAssociatedTextArea {
    autofocus: boolean;
    cols: number;
    // @internal
    control: HTMLTextAreaElement;
    // @internal (undocumented)
    defaultSlottedNodes: Node[];
    formId: string;
    // @internal
    handleChange(): void;
    // @internal (undocumented)
    handleTextInput: () => void;
    list: string;
    maxlength: number;
    minlength: number;
    name: string;
    placeholder: string;
    readOnly: boolean;
    resize: TextAreaResize;
    rows: number;
    spellcheck: boolean;
    }

// @internal
export interface TextArea extends DelegatesARIATextbox {
}

// @public
export enum TextAreaResize {
    both = "both",
    horizontal = "horizontal",
    none = "none",
    vertical = "vertical"
}

// @public
export const TextAreaTemplate: import("@microsoft/fast-element").ViewTemplate<TextArea, any>;

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-forgotten-export) The symbol "FormAssociatedTextField" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "TextField" because one of its declarations is marked as @internal
//
// @public
export class TextField extends FormAssociatedTextField {
    autofocus: boolean;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal
    control: HTMLInputElement;
    // @internal (undocumented)
    defaultSlottedNodes: Node[];
    // @internal
    handleChange(): void;
    // @internal
    handleTextInput(): void;
    list: string;
    maxlength: number;
    minlength: number;
    pattern: string;
    placeholder: string;
    readOnly: boolean;
    size: number;
    spellcheck: boolean;
    type: TextFieldType;
    }

// @internal
export interface TextField extends StartEnd, DelegatesARIATextbox {
}

// @public
export const TextFieldTemplate: import("@microsoft/fast-element").ViewTemplate<TextField, any>;

// @public
export enum TextFieldType {
    email = "email",
    password = "password",
    tel = "tel",
    text = "text",
    url = "url"
}

// @public
export class Tooltip extends FASTElement {
    anchor: string;
    anchorElement: HTMLElement | null;
    // (undocumented)
    connectedCallback(): void;
    // @internal
    currentDirection: Direction;
    delay: number;
    // (undocumented)
    disconnectedCallback(): void;
    // @internal
    handlePositionChange: (ev: Event) => void;
    // @internal (undocumented)
    horizontalDefaultPosition: string | undefined;
    // @internal (undocumented)
    horizontalInset: string;
    // @internal (undocumented)
    horizontalPositioningMode: AxisPositioningMode;
    // @internal (undocumented)
    horizontalScaling: AxisScalingMode;
    position: TooltipPosition;
    // @internal
    region: AnchoredRegion;
    // @internal (undocumented)
    tooltipVisible: boolean;
    // @internal (undocumented)
    verticalDefaultPosition: string | undefined;
    // @internal (undocumented)
    verticalInset: string;
    // @internal (undocumented)
    verticalPositioningMode: AxisPositioningMode;
    // @internal (undocumented)
    verticalScaling: AxisScalingMode;
    // @internal
    viewportElement: HTMLElement | null;
    visible: boolean;
    }

// @public
export enum TooltipPosition {
    bottom = "bottom",
    end = "end",
    left = "left",
    right = "right",
    start = "start",
    top = "top"
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "TreeItem" because one of its declarations is marked as @internal
//
// @public
export class TreeItem extends FASTElement {
    // (undocumented)
    childItemLength(): number;
    // (undocumented)
    childItems: HTMLElement[];
    // @internal (undocumented)
    connectedCallback(): void;
    disabled: boolean;
    // @internal (undocumented)
    disconnectedCallback(): void;
    // (undocumented)
    expandCollapseButton: HTMLDivElement;
    expanded: boolean;
    // (undocumented)
    focusable: boolean;
    static focusItem(el: HTMLElement): void;
    // @deprecated (undocumented)
    handleBlur: (e: FocusEvent) => void;
    // (undocumented)
    handleChange(source: any, propertyName: string): void;
    // (undocumented)
    handleClick: (e: MouseEvent) => void;
    // (undocumented)
    handleExpandCollapseButtonClick: (e: MouseEvent) => void;
    // @deprecated (undocumented)
    handleFocus: (e: Event) => void;
    handleKeyDown: (e: KeyboardEvent) => void | boolean;
    // (undocumented)
    readonly isNestedItem: () => boolean;
    // (undocumented)
    items: HTMLElement[];
    // @internal (undocumented)
    nested: boolean;
    // (undocumented)
    renderCollapsedChildren: boolean;
    selected: boolean;
    }

// @internal
export interface TreeItem extends StartEnd {
}

// @public
export const TreeItemTemplate: import("@microsoft/fast-element").ViewTemplate<TreeItem, any>;

// @public
export class TreeView extends FASTElement {
    // (undocumented)
    connectedCallback(): void;
    // (undocumented)
    currentSelected: HTMLElement | TreeItem | null;
    // @deprecated (undocumented)
    focusable: boolean;
    // (undocumented)
    handleBlur: (e: FocusEvent) => void;
    // @deprecated (undocumented)
    handleFocus: (e: FocusEvent) => void;
    // (undocumented)
    handleKeyDown: (e: KeyboardEvent) => void | boolean;
    // (undocumented)
    renderCollapsedNodes: boolean;
    // (undocumented)
    slottedTreeItems: HTMLElement[];
    // (undocumented)
    treeView: HTMLElement;
}

// @public
export const TreeViewTemplate: import("@microsoft/fast-element").ViewTemplate<TreeView, any>;

// @beta
export type VerticalPosition = "top" | "bottom" | "unset";

// @public
export function whitespaceFilter(value: Node, index: number, array: Node[]): boolean;


// (No @packageDocumentation comment for this package)

```
